<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <script>
        var arrayFinal = []
        var primera = true;
        var cadenaArray
        function transforma(cadena){
            arrayFinal = [];
            if(primera){
                var cadenaSinEspacios = cadena.trim();
                cadenaArray = cadenaSinEspacios.split(' ');
                primera = false;
            }
    
            for(var i = 0; i < cadenaArray.length; i++){
                if(cadenaArray[i].length > 3){
                    desorganiza(cadenaArray[i]);
                }
                else{
                    arrayFinal.push(cadenaArray[i]);
                }
            }
            document.getElementById('texto').innerHTML = arrayFinal.join(' ');

        }
        function desorganiza(string) {
            var primera = string[0];
            var ultima = string[(string.length - 1)];
            do{
                var cadena = string.substr(1, (string.length - 2));
                var arrayLetras = cadena.split('');
                arrayLetras.sort(function(a, b){return 0.5 - Math.random()})
                var final = primera + arrayLetras.join('') + ultima;
            }  
            while(string === final);
            arrayFinal.push(final);
        }
    </script>
    <title>Document</title>
</head>
<body>
    <p id="texto">prueba del ejercicio</p>
    <button onclick="transforma(document.getElementById('texto').innerHTML)">prueba</button>
    
</body>
</html>